
/****************/
/* 9. ε  */
/****************/


/* -------------------------------
       <ǽ1> p434 ~ p438
---------------------------------*/

USE tempDB
CREATE TABLE  
	(	a INT PRIMARY KEY,
		b INT,
		c INT
	)

CREATE TABLE  tbl2
	(	a INT PRIMARY KEY,
		b INT UNIQUE,
		c INT UNIQUE,
		d INT
	)
GO
EXEC sp_helpindex tbl2

CREATE TABLE  tbl3
	(	a INT PRIMARY KEY NONCLUSTERED,
		b INT UNIQUE,
		c INT UNIQUE,
		d INT
	)
GO
EXEC sp_helpindex tbl3

CREATE TABLE  tbl4
	(	a INT PRIMARY KEY  NONCLUSTERED,
		b INT UNIQUE  CLUSTERED,
		c INT UNIQUE,
		d INT
	)
GO
EXEC sp_helpindex tbl4

CREATE TABLE  tbl5
	(	a INT PRIMARY KEY  NONCLUSTERED,
		b INT UNIQUE  CLUSTERED,
		c INT UNIQUE  CLUSTERED,
		d INT
	)
GO

CREATE TABLE  tbl5
	(	a INT PRIMARY KEY  ,
		b INT UNIQUE  CLUSTERED ,
		c INT UNIQUE  ,
		d INT 
	)
GO
EXEC sp_helpindex tbl5

USE tempdb
CREATE TABLE userTbl
( userID  nchar(8) NOT NULL PRIMARY KEY, 
  name    nvarchar(10) , 
  birthYear   int ,  
  addr	  nchar(4)  
)

INSERT INTO userTbl VALUES(N'PJS', N'', 1983, N'')
INSERT INTO userTbl VALUES(N'PJY', N'ֿ', 1986, N'')
INSERT INTO userTbl VALUES(N'JJJ', N'', 1986, N'')
INSERT INTO userTbl VALUES(N'LCS', N'õ', 1983, N'õ')
INSERT INTO userTbl VALUES(N'AJH', N'ȯ', 1979, N'')
GO
SELECT * FROM userTbl


-----------------
-- P443 ~ P448
-----------------

USE tempDB;
CREATE TABLE clusterTbl (userID  NCHAR(3)NOT NULL, name NCHAR(3))
GO
INSERT INTO clusterTbl VALUES(N'PJS', N'')
INSERT INTO clusterTbl VALUES(N'PJY', N'ֿ')
INSERT INTO clusterTbl VALUES(N'JJJ', N'')
INSERT INTO clusterTbl VALUES(N'LCS', N'õ')
INSERT INTO clusterTbl VALUES(N'AJH', N'ȯ')
INSERT INTO clusterTbl VALUES(N'KNI', N'賲')
INSERT INTO clusterTbl VALUES(N'LYP', N'̿ǥ')
INSERT INTO clusterTbl VALUES(N'SKH', N'')
INSERT INTO clusterTbl VALUES(N'SJK', N'')
INSERT INTO clusterTbl VALUES(N'CJC', N'ö')
GO

SELECT * FROM clusterTbl

ALTER TABLE clusterTbl
	ADD CONSTRAINT PK_clusterTbl_userID
		PRIMARY KEY (userID)

SELECT * FROM clusterTbl

CREATE TABLE nonclusterTbl (userID  NCHAR(3)NOT NULL, name NCHAR(3))
GO
INSERT INTO nonclusterTbl VALUES(N'PJS', N'')
INSERT INTO nonclusterTbl VALUES(N'PJY', N'ֿ')
INSERT INTO nonclusterTbl VALUES(N'JJJ', N'')
INSERT INTO nonclusterTbl VALUES(N'LCS', N'õ')
INSERT INTO nonclusterTbl VALUES(N'AJH', N'ȯ')
INSERT INTO nonclusterTbl VALUES(N'KNI', N'賲')
INSERT INTO nonclusterTbl VALUES(N'LYP', N'̿ǥ')
INSERT INTO nonclusterTbl VALUES(N'SKH', N'')
INSERT INTO nonclusterTbl VALUES(N'SJK', N'')
INSERT INTO nonclusterTbl VALUES(N'CJC', N'ö')
GO

ALTER TABLE nonclusterTbl
	ADD CONSTRAINT UK_nonclusterTbl_userID
		UNIQUE (userID)

SELECT * FROM nonclusterTbl

INSERT INTO clusterTbl VALUES(N'HJY', N'ֿ')
INSERT INTO clusterTbl VALUES(N'DTY', N'')

INSERT INTO nonclusterTbl VALUES(N'HJY', N'ֿ')
INSERT INTO nonclusterTbl VALUES(N'DTY', N'')


/* -------------------------------
       <ǽ2> p450 ~ p455
---------------------------------*/

USE tempDB
CREATE TABLE mixedTbl 
	(userID  NCHAR(3)NOT NULL, name NCHAR(3), addr NCHAR(2))
GO
INSERT INTO mixedTbl VALUES(N'PJS', N'', N'')
INSERT INTO mixedTbl VALUES(N'PJY', N'ֿ', N'')
INSERT INTO mixedTbl VALUES(N'JJJ', N'', N'')
INSERT INTO mixedTbl VALUES(N'LCS', N'õ', N'õ')
INSERT INTO mixedTbl VALUES(N'AJH', N'ȯ', N'')
INSERT INTO mixedTbl VALUES(N'KNI', N'賲', N'')
INSERT INTO mixedTbl VALUES(N'LYP', N'̿ǥ', N'')
INSERT INTO mixedTbl VALUES(N'SKH', N'', N'')
INSERT INTO mixedTbl VALUES(N'SJK', N'', N'')
INSERT INTO mixedTbl VALUES(N'CJC', N'ö', N'')
GO

ALTER TABLE mixedTbl
	ADD CONSTRAINT PK_mixedTbl_userID
		PRIMARY KEY (userID)
GO

ALTER TABLE mixedTbl
	ADD CONSTRAINT UK_mixedTbl_name
		UNIQUE (name)
GO

Select addr from mixedTbl where name = ''

select * from mixedTbl where userId = 'JJJ'

select * from mixedTbl


-----------------
-- P457 ~ P459
-----------------

-- ⼭ (P457)
SELECT * FROM sys.indexes WHERE object_id('userTbl') = object_id

USE master
GO
ALTER DATABASE sqlDB SET OFFLINE
GO
ALTER INDEX ALL ON userTbl REBUILD
GO
ALTER DATABASE sqlDB SET ONLINE
GO

-- ⼭ (P459)
USE sqlDB
GO
SELECT a.index_id, name, avg_fragmentation_in_percent
FROM sys.dm_db_index_physical_stats (DB_ID(), OBJECT_ID('dbo.userTbl'),
     NULL, NULL, NULL) AS a
      INNER JOIN sys.indexes AS b 
       ON a.object_id = b.object_id AND a.index_id = b.index_id;
GO

/* -------------------------------
       <ǽ3> p460 ~ p463
---------------------------------*/

USE master
RESTORE DATABASE sqlDB FROM DISK ='c:\sqldb.bak' WITH REPLACE

USE sqlDB
SELECT * FROM userTbl

USE sqlDB
GO
EXEC sp_helpindex userTbl

CREATE INDEX idx_userTbl_addr
	ON userTbl (addr)

CREATE UNIQUE INDEX idx_userTbl_birtyYear
	ON userTbl (birthYear)

CREATE UNIQUE INDEX idx_userTbl_name
	ON userTbl (name)

INSERT INTO userTbl VALUES(N'AZH', N'ȯ', 1983, N'̱', NULL  , NULL      , 162)

CREATE NONCLUSTERED INDEX idx_userTbl_name_birthYear
	ON userTbl (name,birthYear)

SELECT * FROM userTbl WHERE name = 'ȯ' and birthYear = '1979'

CREATE NONCLUSTERED INDEX idx_userTbl_mobile1
	ON userTbl (mobile1)

SELECT * FROM userTbl WHERE mobile1 = '011'

DROP INDEX userTbl.idx_userTbl_addr
DROP INDEX userTbl.idx_userTbl_name
DROP INDEX userTbl.idx_userTbl_name_birthYear

DROP INDEX userTbl.PK__userTbl__7C8480AE -- ڿ ٸ  

ALTER TABLE userTbl
	DROP CONSTRAINT PK__userTbl__7C8480AE  -- ڿ ٸ  

ALTER TABLE buyTbl
	DROP CONSTRAINT FK__buyTbl__userid__7F60ED59  -- ڿ ٸ  
GO
ALTER TABLE userTbl
	DROP CONSTRAINT PK__userTbl__7C8480AE  -- ڿ ٸ  
GO


/* -------------------------------
       <ǽ4> p464 ~ p476
---------------------------------*/

use master
CREATE DATABASE indexDB
GO

USE indexDB
GO
CREATE PROCEDURE sp_IndexInfo
	@tablename sysname
AS
SELECT	 @tablename AS '̸̺', 
		I.name AS 'ε̸',
		I.type_desc AS 'εŸ',
		A.data_pages AS '', --   
		A.data_pages * 8 AS 'ũ(KB)', --   KB(1page = 8KB)ΰ
		P.rows AS 'ళ'
FROM sys.indexes I 
	INNER JOIN sys.partitions P
		ON P.object_id = I.object_id 
			AND OBJECT_ID(@tablename) = I.object_id
			AND I.index_id = P.index_id
	INNER JOIN sys.allocation_units A
		ON A.container_id = P.hobt_id 
GO

USE indexDB
SELECT COUNT(*) FROM AdventureWorks.Sales.Customer

Select * INTO Cust from AdventureWorks.Sales.Customer ORDER BY TerritoryID
Select * INTO Cust_C from AdventureWorks.Sales.Customer ORDER BY rowguid asc
Select * INTO Cust_NC from AdventureWorks.Sales.Customer ORDER BY rowguid desc

SELECT TOP(5)* FROM Cust;
SELECT TOP(5)* FROM Cust_C;
SELECT TOP(5)* FROM Cust_NC;

EXEC sp_IndexInfo Cust;
EXEC sp_IndexInfo Cust_C;
EXEC sp_IndexInfo Cust_NC;

CREATE CLUSTERED INDEX idx_cust_c on Cust_C (CustomerID);
CREATE NONCLUSTERED INDEX idx_cust_nc on Cust_NC (CustomerID);

SELECT TOP(5)* FROM Cust;
SELECT TOP(5)* FROM Cust_C;
SELECT TOP(5)* FROM Cust_NC;

EXEC sp_IndexInfo Cust;
EXEC sp_IndexInfo Cust_C;
EXEC sp_IndexInfo Cust_NC;

USE indexDB

SELECT * FROM Cust WHERE CustomerID = 100

SELECT * FROM Cust_C WHERE CustomerID = 100

SELECT * FROM Cust_NC WHERE CustomerID = 100

SELECT * FROM Cust WHERE CustomerID < 100

SELECT * FROM Cust_C WHERE CustomerID < 100

SELECT * FROM Cust_C WHERE CustomerID < 200

SELECT * FROM Cust_C WHERE CustomerID < 30000

SELECT * FROM Cust_C 

SELECT * FROM Cust_NC WHERE CustomerID < 100

SELECT * FROM Cust_NC WITH (INDEX(idx_cust_nc))
WHERE CustomerID < 100

SELECT * FROM Cust_NC WHERE CustomerID < 50

SELECT * FROM Cust_NC WHERE CustomerID < 45

Select * INTO Cust2_C from AdventureWorks.Sales.Customer ORDER BY rowguid
Select * INTO Cust2_NC from AdventureWorks.Sales.Customer ORDER BY rowguid
GO
CREATE CLUSTERED INDEX idx_cust2_c on Cust2_C (CustomerType);
CREATE NONCLUSTERED INDEX idx_cust2_nc on Cust2_NC (CustomerType);

SELECT * FROM Cust2_C WHERE CustomerType = 'S'

SELECT DISTINCT CustomerType FROM Cust2_NC


-----------------
-- P477 ~ P479
-----------------

SELECT name, birthYear, addr FROM userTbl WHERE userID = 'JJJ'

USE sqlDB
SELECT userID, name, birthYear FROM userTbl WHERE birthYear < 1979
SELECT userID, name, height FROM userTbl WHERE height < 179


/* -------------------------------
       <ǽ5> p481
---------------------------------*/

CREATE TABLE computeTbl (input1 INT, input2 INT, hap AS input1+input2 PERSISTED) ;

INSERT INTO computeTbl VALUES(100,100)
INSERT INTO computeTbl VALUES(200,200)
INSERT INTO computeTbl VALUES(300,300)
INSERT INTO computeTbl VALUES(400,400)
INSERT INTO computeTbl VALUES(500,500)
GO
SELECT * FROM computeTbl

CREATE CLUSTERED INDEX idx_computeTbl_hap ON computeTbl(hap) ;

/* -------------------------------
       <ǽ6> p482 ~ p485
---------------------------------*/

USE indexDB
SELECT CustomerID, AccountNumber, CustomerType FROM Cust_NC WHERE CustomerID < 100

Select * INTO Cust_Include from AdventureWorks.Sales.Customer ORDER BY rowguid

CREATE NONCLUSTERED INDEX idx_cust_include 
		ON Cust_Include (CustomerID) 
		INCLUDE (AccountNumber,CustomerType);

SELECT CustomerID, AccountNumber, CustomerType FROM Cust_Include WHERE CustomerID < 100

SELECT * FROM Cust_Include WHERE CustomerID < 100

CREATE TABLE testTbl (a  VARCHAR(400), b VARCHAR(400), c VARCHAR(400))

CREATE NONCLUSTERED INDEX idx_testTbl_abc ON testTbl (a,b,c)

INSERT INTO testTbl VALUES (REPLICATE('A',100),REPLICATE('B',100),REPLICATE('C',100))

INSERT INTO testTbl VALUES ( REPLICATE('A',400), REPLICATE('B',400),REPLICATE('C',400))

DROP INDEX testTbl.idx_testTbl_abc
GO
CREATE NONCLUSTERED INDEX idx_testTbl_abc ON testTbl (a) INCLUDE (b,c)
GO
INSERT INTO testTbl VALUES ( REPLICATE('A',400), REPLICATE('B',400),REPLICATE('C',400))


/* -------------------------------
       <ǽ7> p486 ~ p493
---------------------------------*/

USE master;
CREATE DATABASE tuningDB;

USE tuningDB;
SELECT ProductID, Name, Color, Size, Weight 
	INTO ProductTbl FROM AdventureWorks.Production.Product;
SELECT SalesOrderDetailID AS OrderID, ProductID, OrderQty, 
		UnitPrice, LineTotal AS Total
	INTO OrderTbl FROM AdventureWorks.Sales.SalesOrderDetail;

ALTER TABLE ProductTbl
	ADD CONSTRAINT pk_ProductTbl
		PRIMARY KEY (ProductID);
ALTER TABLE OrderTbl
	ADD CONSTRAINT pk_OrderTbl
		PRIMARY KEY (OrderID);
ALTER TABLE OrderTbl
	ADD CONSTRAINT fk_OrderTbl
		FOREIGN KEY (ProductID)
		REFERENCES ProductTbl (ProductID);

SELECT COUNT(*) FROM ProductTbl;
SELECT COUNT(*) FROM OrderTbl;

SELECT TOP(5) * FROM ProductTbl;
SELECT TOP(5) * FROM OrderTbl;

SELECT P.ProductID, P.Name, SUM(O.OrderQty) AS [ֹ], SUM(O.Total) AS [Ǹž]
	FROM ProductTbl P
		INNER JOIN OrderTbl O
			ON P.ProductID = O.ProductID
	GROUP BY P.ProductID, P.Name
	HAVING P.ProductID = 717; -- 1
SELECT * FROM ProductTbl WHERE COLOR = 'Silver' ORDER BY name; -- 2
SELECT  ProductID, Total FROM OrderTbl ORDER BY Total DESC; -- 3

use tuningDB

CREATE NONCLUSTERED INDEX [_dta_index_OrderTbl_11_2089058478__K5D_2_3] ON [dbo].[OrderTbl] 
(
	[Total] DESC
)
INCLUDE ( [ProductID],
[OrderQty]) WITH (SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, IGNORE_DUP_KEY = OFF, ONLINE = OFF) ON [PRIMARY]

CREATE NONCLUSTERED INDEX [_dta_index_OrderTbl_11_2089058478__K2_3_5] ON [dbo].[OrderTbl] 
(
	[ProductID] ASC
)
INCLUDE ( [OrderQty],
[Total]) WITH (SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, IGNORE_DUP_KEY = OFF, ONLINE = OFF) ON [PRIMARY]


/* -------------------------------
       <ǽ8> p495 ~ p496
---------------------------------*/

USE master
RESTORE DATABASE sqlDB FROM DISK ='c:\sqldb.bak' WITH REPLACE
GO
USE partTblDB
SELECT * INTO userTbl_noPart FROM sqlDB.dbo.userTbl

SELECT * FROM userTbl
WHERE $PARTITION.birtyYearRangePF(birthYear) = 1 ;
SELECT * FROM userTbl
WHERE $PARTITION.birtyYearRangePF(birthYear) = 2 ;
SELECT * FROM userTbl
WHERE $PARTITION.birtyYearRangePF(birthYear) = 3 ;

CREATE CLUSTERED INDEX idx_userTbl_noPart_birthYear
	ON userTbl_noPart (birthYear DESC);
CREATE CLUSTERED INDEX idx_userTbl_birthYear
	ON userTbl (birthYear DESC);

SELECT * FROM userTbl_noPart

SELECT * FROM userTbl


/* -------------------------------
       <ǽ9> p498 ~ p502
---------------------------------*/

USE AdventureWorks;

SELECT P.ProductID, P.Name, SUM(O.OrderQty) AS SumOrderQty, 
		SUM(O.LineTotal) AS SumLineTotal
FROM Production.Product P
	INNER JOIN Sales.SalesOrderDetail O
		ON P.ProductID = O.ProductID
GROUP BY P.ProductID, P.Name;

CREATE VIEW vProductSum WITH SCHEMABINDING AS
		SELECT P.ProductID, COUNT_BIG(*) AS Count, P.Name, 
			SUM(O.OrderQty) AS SumOrderQty, SUM(O.LineTotal) AS SumLineTotal
		FROM Production.Product P
			INNER JOIN Sales.SalesOrderDetail O
				ON P.ProductID = O.ProductID
		GROUP BY P.ProductID, P.Name;
GO
CREATE UNIQUE CLUSTERED INDEX vIdx_vProductSum ON vProductSum (ProductID);

EXEC sp_helpindex vProductSum;
EXEC sp_IndexInfo vProductSum; -- <ǽ 4>  ν ( ص )

SELECT * FROM vProductSum

SELECT P.ProductID, P.Name, SUM(O.OrderQty) AS SumOrderQty, 
		SUM(O.LineTotal) AS SumLineTotal
FROM Production.Product P
	INNER JOIN Sales.SalesOrderDetail O
		ON P.ProductID = O.ProductID
GROUP BY P.ProductID, P.Name;

SELECT ProductID, Name FROM Production.Product WHERE (ListPrice - StandardCost) >= 1000

CREATE VIEW vProfit WITH SCHEMABINDING  AS
	SELECT ProductID, Name , (ListPrice - StandardCost) AS Profit FROM Production.Product ;
GO
CREATE UNIQUE CLUSTERED INDEX vIdx_vProfit ON vProfit (ProductID);

SELECT ProductID, Name FROM Production.Product WHERE (ListPrice - StandardCost) >= 1000

SELECT ProductID, Name FROM Production.Product WHERE (ListPrice - StandardCost) >= 500

DBCC SHOW_STATISTICS ('vProfit', 'vIdx_vProfit')


