
/*******************************************/
/* 11.  ν   Լ  */
/*******************************************/

-----------------
-- P555
-----------------

USE sqlDB;
GO
CREATE PROCEDURE usp_users
AS
	SELECT * FROM userTbl;
GO

EXEC usp_users;


/* -------------------------------
       <ǽ1> p558 ~ p568
---------------------------------*/

USE master;
RESTORE DATABASE sqlDB FROM DISK = 'C:\sqlDB.bak' WITH REPLACE

USE sqlDB;
GO
CREATE PROCEDURE usp_users1
	@userName NVARCHAR(10)
AS
	SELECT * FROM userTbl WHERE name = @userName;
GO

EXEC usp_users1 'õ';

CREATE PROCEDURE usp_users2
	@userBirth INT,
	@userHeight INT
AS
	SELECT * FROM userTbl 
	WHERE birthYear > @userBirth AND height > @userHeight;
GO

EXEC usp_users2 1980, 180;

EXEC usp_users2  @userHeight=180, @userBirth=1980 ;

CREATE PROCEDURE usp_users3
	@userBirth INT = 1980,
	@userHeight INT = 180
AS
	SELECT * FROM userTbl 
	WHERE birthYear > @userBirth AND height > @userHeight;
GO

EXEC usp_users3;

CREATE PROCEDURE usp_users4
	@txtValue NCHAR(10),
	@outValue INT OUTPUT
AS
	INSERT INTO testTbl VALUES(@txtValue);
	SELECT @outValue = IDENT_CURRENT('testTbl');  -- ̺ identity 
GO

CREATE TABLE testTbl (id INT IDENTITY, txt NCHAR(10));
GO

DECLARE @myValue INT;
EXEC usp_users4 '׽Ʈ1', @myValue OUTPUT;
PRINT ' Էµ ID  ==> ' + CAST(@myValue AS CHAR(5));

CREATE PROC usp_ifElse
	@userName nvarchar(10)
AS
	DECLARE @bYear INT --   
	SELECT @bYear = birthYear FROM userTbl
		WHERE name = @userName;
	IF (@bYear >= 1980)
		BEGIN
			PRINT N' ..';
		END
	ELSE
		BEGIN
			PRINT N'̰ ϳ׿..';
		END
GO
	
EXEC usp_ifElse 'ֿ';

CREATE PROC usp_case
	@userName nvarchar(10)
AS
	DECLARE @bYear INT 
	DECLARE @tti NCHAR(3) -- 
	SELECT @bYear = birthYear FROM userTbl
		WHERE name = @userName;

	SET @tti =
		CASE
			WHEN ( @bYear%12 = 	0) THEN ''
			WHEN ( @bYear%12 = 	1) THEN '' 
			WHEN ( @bYear%12 = 	2) THEN '' 
			WHEN ( @bYear%12 = 	3) THEN '' 
			WHEN ( @bYear%12 = 	4) THEN '' 
			WHEN ( @bYear%12 = 	5) THEN '' 
			WHEN ( @bYear%12 = 	6) THEN 'ȣ' 
			WHEN ( @bYear%12 = 	7) THEN '䳢' 
			WHEN ( @bYear%12 = 	8) THEN '' 
			WHEN ( @bYear%12 = 	9) THEN '' 
			WHEN ( @bYear%12 = 	10) THEN '' 
			ELSE ''
		END;
	PRINT @userName + ' ==> ' + @tti;
GO
	
EXEC usp_case '';

USE sqlDB;
GO
ALTER TABLE userTbl
	ADD  grade NVARCHAR(5);  --   ߰
GO
CREATE PROCEDURE usp_while
AS
	DECLARE userCur CURSOR FOR-- Ŀ 
		SELECT U.userid,sum(price*amount)
		FROM buyTbl B
			RIGHT OUTER JOIN userTbl U
			ON B.userid = U.userid
		GROUP BY U.userid, U.name 

	OPEN userCur  -- Ŀ

	DECLARE @id NVARCHAR(10) -- ھ̵  
	DECLARE @sum BIGINT -- ѱž  
	DECLARE @userGrade NCHAR(5) --   

	FETCH NEXT FROM userCur INTO @id, @sum -- ù  

	WHILE (@@FETCH_STATUS=0) --    ݺ(,   ó)
	BEGIN
		SET @userGrade =
			CASE  
				WHEN (@sum >= 1500) THEN N'ֿ'
				WHEN (@sum  >= 1000) THEN N''
				WHEN (@sum >= 1 ) THEN N'Ϲݰ'
				ELSE N'ɰ'
			 END
		UPDATE userTbl SET grade = @userGrade WHERE userID = @id
		FETCH NEXT FROM userCur INTO @id, @sum --   
	END

	CLOSE userCur  -- Ŀ ݱ
	DEALLOCATE userCur -- Ŀ 
GO

SELECT * FROM userTbl

EXEC usp_while;
SELECT * FROM userTbl;

CREATE PROC usp_return
	@userName nvarchar(10)
AS
	DECLARE @userGrade NVARCHAR(5);
	SELECT @userGrade = grade FROM userTbl 
			 WHERE name = @userName;
	IF (@userGrade <> '')
		RETURN 0;  --  , ׳ RETURN ᵵ 0 
	ELSE
		RETURN -1; --  (, ش ̸ ID  )
GO

DECLARE @retVal INT ;
EXEC @retVal=usp_return 'ȯ' ;
SELECT @retVAl;

DECLARE @retVal INT ;
EXEC @retVal=usp_return '糲' ;
SELECT @retVAl;

CREATE PROC usp_error
	@userid nvarchar(10),
	@name nvarchar(10),
	@birthYear INT = 1900,
	@addr NCHAR(4) = '',
	@mobile1 NCHAR(3) = NULL,
	@mobile2 NCHAR(8) = NULL,
	@height smallInt = 180

AS
	DECLARE @err INT;
	INSERT INTO userTbl(userID,name,birthYear,addr,mobile1,mobile2,height)
	  VALUES (@userid,@name,@birthYear,@addr,@mobile1,@mobile2,@height);

	SELECT @err = @@ERROR;
	IF @err != 0
	BEGIN
		PRINT  '###' + @name + '() INSERT߽ϴ. ###'
	END;

	RETURN @err; -- ȣ .
GO

DECLARE @errNum INT;
EXEC @errNum = usp_error 'WDT','' ;
IF (@errNum != 0)
	SELECT  @errNum;

CREATE PROC usp_tryCatch
	@userid nvarchar(10),
	@name nvarchar(10),
	@birthYear INT = 1900,
	@addr NCHAR(4) = '',
	@mobile1 NCHAR(3) = NULL,
	@mobile2 NCHAR(8) = NULL,
	@height smallInt = 180
AS
	DECLARE @err INT;
	BEGIN TRY 
	  INSERT INTO 
userTbl(userID,name,birthYear,addr,mobile1,mobile2,height)
		 VALUES (@userid, @name, @birthYear, @addr,	@mobile1, 
@mobile2,	@height)
	END TRY
	
	BEGIN CATCH
		SELECT ERROR_NUMBER()
		SELECT ERROR_MESSAGE()
	END CATCH
GO

EXEC usp_tryCatch 'DRJY','' ;

USE sqlDB;
SELECT o.name, m.definition  
FROM sys.sql_modules m
	JOIN sys.objects o 
	ON m.object_id = o.object_id AND o.TYPE = 'P';

EXECUTE sp_helptext usp_error;

CREATE PROC usp_Encrypt WITH ENCRYPTION
AS
   SELECT SUBSTRING(name,1,1) + 'OO' as [̸], 
		  birthYear as '⵵', height as '' FROM userTbl;
GO

EXECUTE usp_Encrypt;

EXECUTE sp_helptext usp_Encrypt;

CREATE PROC #usp_temp
AS
	SELECT * FROM userTbl;
GO
EXEC #usp_temp;

EXEC sp_executesql N'SELECT * FROM userTbl';


-----------------
-- P569
-----------------

CREATE PROC usp_Deliv 
	@id NVARCHAR(10)
AS
   SELECT userID,name,addr,mobile1,mobile2 
	FROM userTbl
	WHERE userID = @id;
GO

EXEC usp_Deliv 'JJJ';


/* -------------------------------
       <ǽ2> p573 ~ p575
---------------------------------*/

SET STATISTICS TIME ON ;
USE AdventureWorks;

SELECT P.ProductNumber, P.Name AS Product, V.Name AS Vendor, PV.LastReceiptCost
FROM Production.Product AS P
    JOIN Purchasing.ProductVendor AS PV ON P.ProductID = PV.ProductID
    JOIN Purchasing.Vendor AS V ON V.VendorID = PV.VendorID
ORDER BY P.Name ;

SELECT P.ProductNumber, P.Name AS Product, V.Name AS Vendor, PV.LastReceiptCost
FROM Production.Product AS P
    JOIN Purchasing.ProductVendor AS PV ON P.ProductID = PV.ProductID
    JOIN Purchasing.Vendor AS V ON V.VendorID = PV.VendorID
ORDER BY P.Name ;

sELECT P.ProductNumber, P.Name AS Product, V.Name AS Vendor, PV.LastReceiptCost
FROM Production.Product AS P
    JOIN Purchasing.ProductVendor AS PV ON P.ProductID = PV.ProductID
    JOIN Purchasing.Vendor AS V ON V.VendorID = PV.VendorID
ORDER BY P.Name ;

SELECT P.ProductNumber, P.Name AS Product, V.Name AS Vendor, PV.LastReceiptCost
FROM Production.Product AS P
    JOIN Purchasing.ProductVendor AS PV ON P.ProductID = PV.ProductID
    JOIN Purchasing.Vendor AS V ON V.VendorID = PV.VendorID
ORDER BY P.Name ;


/* -------------------------------
       <ǽ3> p576 ~ p578
---------------------------------*/

SET STATISTICS TIME ON ;
USE AdventureWorks;

CREATE PROCEDURE usp_Prod
AS
	SELECT P.ProductNumber, P.Name AS Product, V.Name AS Vendor, PV.LastReceiptCost
	FROM Production.Product AS P
		JOIN Purchasing.ProductVendor AS PV ON P.ProductID = PV.ProductID
		JOIN Purchasing.Vendor AS V ON V.VendorID = PV.VendorID
	ORDER BY P.Name ;
GO

EXEC usp_Prod;

SET STATISTICS TIME OFF;

-- ⼭ (P577)
SELECT * FROM userTbl WEHRE id = 'AJH';
SELECT * FROM userTbl WEHRE id = 'LCS';
SELECT * FROM userTbl WEHRE id = 'JJJ';

CREATE PROC usp_id
	@id NVARCHAR(10)
AS
	SELECT * FROM userTbl WHERE userID = @id

EXEC usp_id 'AJH';
EXEC usp_id 'LCS';
EXEC usp_id 'JJJ';


/* -------------------------------
       <ǽ4> p579 ~ p582
---------------------------------*/

USE sqlDB;
Select * INTO spTbl from AdventureWorks.Sales.Customer ORDER BY rowguid;
CREATE NONCLUSTERED INDEX idx_spTbl_id on spTbl (CustomerID);

SELECT * FROM spTbl WHERE CustomerID < 10;

SELECT * FROM spTbl WHERE CustomerID < 5000;

CREATE PROC usp_ID
	@id INT
AS
	SELECT * FROM spTbl WHERE CustomerID < @id; 
GO

EXEC usp_ID 10;

EXEC usp_ID 5000;

EXEC usp_ID 5000 WITH RECOMPILE;

EXEC sp_recompile spTbl;
EXEC usp_ID 10;

EXEC usp_ID 10;

DBCC FREEPROCCACHE;
EXEC usp_ID 5000;

DROP PROC usp_ID;
GO
CREATE PROC usp_ID 
	@id INT
WITH RECOMPILE
AS
	SELECT * FROM spTbl WHERE CustomerID < @id; 
GO


/* -------------------------------
       <ǽ5> p584 ~ p585
---------------------------------*/

USE sqlDB;
GO

CREATE FUNCTION ufn_getAge(@byear INT) -- Ű  
	RETURNS INT  -- ϰ 
AS
	BEGIN
		DECLARE @age INT
		SET @age = YEAR(GETDATE()) - @byear
		RETURN(@age)
	END
GO

SELECT dbo.ufn_getAge(1979); -- ȣ Ű ٿ 

DECLARE @retVal INT;
EXEC @retVal = dbo.ufn_getAge 1979; 
PRINT @retVal;

SELECT userID, name, dbo.ufn_getAge(birthYear) AS [ ] FROM userTbl;

ALTER FUNCTION ufn_getAge(@byear INT) 
	RETURNS INT  
AS
	BEGIN
		DECLARE @age INT
		SET @age = YEAR(GETDATE()) - @byear + 1
		RETURN(@age)
	END
GO

DROP FUNCTION ufn_getAge;


/* -------------------------------
       <ǽ6> p588 ~ p590
---------------------------------*/

USE sqlDB;
GO
CREATE FUNCTION ufn_getUser(@ht INT)
	RETURNS TABLE
AS
	RETURN (
		SELECT userID AS [̵], name AS [̸], height AS [Ű] 
		FROM userTbl
		WHERE height > @ht
	)
GO

SELECT * FROM dbo.ufn_getUser(180);

CREATE FUNCTION ufn_userGrade(@bYear INT)
--  ̺ (@retTable BEGIN..END  ̺)
	RETURNS @retTable TABLE   
		( userID NVARCHAR(10),
		  name	 NVARCHAR(10),
		  grade  NVARCHAR(5) )
AS
BEGIN
	DECLARE @rowCnt INT;
	--   īƮ
	SELECT @rowCnt = COUNT(*) FROM userTbl WHERE birthYear >= @bYear;

	--  ϳ  ''̶ Էϰ ̺ .
	IF @rowCnt <= 0 
	BEGIN
		INSERT INTO @retTable VALUES('','','');
		RETURN; 
	END;

	--  1̻ ִٸ Ʒ ϰԵ
	INSERT INTO @retTable
		SELECT U.userid, U.name, 
			CASE  
				WHEN (sum(price*amount)  >= 1500) THEN N'ֿ'
				WHEN (sum(price*amount)  >= 1000) THEN N''
				WHEN (sum(price*amount) >= 1 ) THEN N'Ϲݰ'
				ELSE N'ɰ'
			 END 
		FROM buyTbl B
		   RIGHT OUTER JOIN userTbl U
			  ON B.userid = U.userid
		WHERE birthYear >= @bYear
		GROUP BY U.userid, U.name;
	RETURN;
END;

SELECT * FROM dbo.ufn_userGrade(1980);

SELECT * FROM dbo.ufn_userGrade(1990);


/* -------------------------------
       <ǽ7> p591 ~ p594
---------------------------------*/

USE master;
RESTORE DATABASE sqlDB FROM DISK = 'C:\sqlDB.bak' WITH REPLACE

CREATE FUNCTION ufn_discount(@id NVARCHAR(10))
	RETURNS BIGINT
AS
BEGIN
	DECLARE @totPrice BIGINT;
	-- Էµ id ѱž
	SELECT @totPrice = sum(price*amount)
		FROM buyTbl 
		WHERE userID = @id
		GROUP BY userID ;
	-- ѱž׿    
	SET @totPrice =
		CASE  
			WHEN (@totPrice >= 1500) THEN @totPrice*0.7
			WHEN (@totPrice >= 1000) THEN @totPrice*0.8
			WHEN (@totPrice >= 500) THEN @totPrice*0.9
			ELSE @totPrice
		 END;
 	-- ű  0
	IF @totPrice IS NULL
		SET @totPrice = 0;

	RETURN @totPrice;	
END

SELECT userID, name, dbo.ufn_discount(userID) AS [εѱž] FROM userTbl;

EXEC sp_rename 'buyTbl.price', 'cost', 'COLUMN'

SELECT userID, name, dbo.ufn_discount(userID) AS [εѱž] FROM userTbl;

EXEC sp_rename 'buyTbl.cost', 'price', 'COLUMN'

ALTER FUNCTION ufn_discount(@id NVARCHAR(10))
	RETURNS BIGINT
WITH SCHEMABINDING
AS
BEGIN
	DECLARE @totPrice BIGINT;
	SELECT @totPrice = sum(price*amount)
		FROM buyTbl 
		WHERE userID = @id
		GROUP BY userID ;
	SET @totPrice =
		CASE  
			WHEN (@totPrice >= 1500) THEN @totPrice*0.7
			WHEN (@totPrice >= 1000) THEN @totPrice*0.8
			WHEN (@totPrice >= 500) THEN @totPrice*0.9
			ELSE @totPrice
		 END;
	IF @totPrice IS NULL
		SET @totPrice = 0;

	RETURN @totPrice;	
END

ALTER FUNCTION ufn_discount(@id NVARCHAR(10))
	RETURNS BIGINT
WITH SCHEMABINDING
AS
BEGIN
	DECLARE @totPrice BIGINT;
	-- ԷµȻidѱž
	SELECT @totPrice = sum(price*amount)
		FROM dbo.buyTbl 
		WHERE userID = @id
		GROUP BY userID ;
	SET @totPrice =
		CASE  
			WHEN (@totPrice >= 1500) THEN @totPrice*0.7
			WHEN (@totPrice >= 1000) THEN @totPrice*0.8
			WHEN (@totPrice >= 500) THEN @totPrice*0.9
			ELSE @totPrice
		 END;
	IF @totPrice IS NULL
		SET @totPrice = 0;

	RETURN @totPrice;	
END

EXEC sp_rename 'buyTbl.price', 'cost', 'COLUMN'

DECLARE @tblVar TABLE (id NVARCHAR(10), name NVARCHAR(10), addr NVARCHAR(5));
INSERT INTO @tblVar 
	SELECT userID, name , addr FROM userTbl WHERE birthYear >= 1980;
SELECT * FROM @tblVar;

CREATE TABLE #tmpTbl 
	(id NVARCHAR(10), name NVARCHAR(10), addr NVARCHAR(5));
INSERT INTO #tmpTbl
	SELECT userID, name , addr FROM userTbl WHERE birthYear >= 1980;
SELECT * FROM #tmpTbl;

-- ⼭  (P595)
DECLARE @tblVar TABLE (id INT);
BEGIN TRAN
	INSERT INTO @tblVar VALUES (1);
	INSERT INTO @tblVar VALUES (2);
ROLLBACK TRAN
SELECT * FROM @tblVar;
